<?php
/**
* class for initiating necessary actions and core functions.
*/
/*
* Defining Namespace
*/
namespace rewordsync\classes;
class Rewordsyncoption
{
    /*
     * Constructor for iniation.
    */
    public function __construct(){
        $this->init();
    }
     /** 
     * Initiating necessary functions
     */
    public function init(){
        add_action( 'admin_menu', array( $this, 'wpdocs_register_my_api_keys_page' ) );
        add_action( 'admin_enqueue_scripts', array( $this, 'reword_sync_script' ) );
        add_action( 'wp_ajax_nopriv_reword_sync_api_genrate', array( $this , 'reword_sync_api_genrate' ) );
        add_action( 'wp_ajax_reword_sync_api_genrate', array( $this , 'reword_sync_api_genrate' ) );
        add_action( 'wp_ajax_nopriv_reword_active_option', array( $this , 'reword_active_option' ) );
        add_action( 'wp_ajax_reword_active_option', array( $this , 'reword_active_option' ) );
        add_action( "init" , array( $this , 'genrate_api_key' ) );
        add_action( 'wp_ajax_crd_get_posts', array( $this , 'crd_get_posts' ) );
        add_action( 'wp_ajax_nopriv_crd_get_posts', array( $this , 'crd_get_posts' ) );
    }
    function genrate_api_key(){
        $option_data = get_option( "reword_sync_call");
        if( empty( $option_data ) ){
            $characters = '0123456789abcdefghijkdsfsfdsfdsretregvXYZ';
            $charactersLength = strlen($characters);
            $randomString = '';
            for ($i = 0; $i < $charactersLength; $i++) {
                $randomString .= $characters[random_int(0, $charactersLength - 1)];
            }
           $option_data = $randomString;
        }
        update_option( "reword_sync_call" , $option_data );
        
    }
    
    public function reword_sync_api_call(){
        if( $_POST ){
            $app_key = get_option( 'reword_sync_call' );
            $custom_api_url = $api_key = $api_url = $post_type = "";
            if( isset( $_POST['data']['custom_api_url'] ) ){
                $custom_api_url = $_POST['data']['custom_api_url'];
            }
            if( isset( $_POST['data']['api_key'] ) ){
                $api_key = $_POST['data']['api_key'];
            }
            if( isset( $_POST['data']['api_url'] ) ){
                $api_url = $_POST['data']['api_url'];
            }
            if( isset( $_POST['data']['post_type'] ) ){
                $post_type = $_POST['data']['post_type'];
            }
            if( !empty( $custom_api_url  ) && !empty( $api_key  ) && !empty( $api_url  ) && !empty( $post_type  ) ){
                $api_data = array(
                    'api_key' => $api_key,
                    's' => $post_type,
                    'next_url' => $api_url
                );
                $result = wp_remote_post( $custom_api_url, array(
                    'timeout'     => 5,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking'    => true,
                    'headers'     => array(),
                    'body'        => $api_data, // request parameters in an array
                    'cookies'     => array()
                ) );
                
                if ( is_wp_error( $result ) ) {
                    $error_message = $response->get_error_message();
                    echo "Something went wrong: $error_message";
                }
                else {
                   
                    $retrive_body = wp_remote_retrieve_body( $result );
                    if(str_contains($retrive_body , "meta" ) !== false){
                        $responce['err'] = "Some data is missing";
                        echo json_encode($responce);
                    }else{
                        echo $retrive_body;
                    }
                }
            }else{
                $responce['err'] = "Some data is missing";
                echo json_encode($responce);
            }
        }
        die();
        
    }
    public function wpdocs_register_my_api_keys_page() {
        add_menu_page(
            'Reword',
            'Reword',
            'manage_options',
            'api-keys',
            array( $this, 'add_api_keys_callback' ) ,
            REWORD_SYNC_DIR . "assets/images/plugin-icon.png",
            
        );
    }
    public function reword_sync_script(){
        wp_enqueue_style( 'reword-sync-css', REWORD_SYNC_DIR .'assets/css/style.css?'.time() );
        wp_enqueue_script( 'reword-sync-js', REWORD_SYNC_DIR .'assets/js/main.js?'.time(), array(), '1.0.0', true );
        wp_localize_script( 'reword-sync-js', 'reword_sync', array(
            'ajax_url' => admin_url( 'admin-ajax.php' ),
            'nonce' => wp_create_nonce('ajax-nonce')
        ));
    }
    public function add_api_keys_callback(){
        include "reword-sync-html.php";
    }
    public function reword_sync_api_genrate(){
        if ( ! wp_verify_nonce( $_POST['nonce'], 'ajax-nonce' ) ) {
            die ("Somthing Went Wrong");
        }
        if( $_POST ){
            
            $wordpress_api = get_option( "reword_sync_call" );
            $api_key = $_POST['api_key'];
            $url = 'https://api.reword.com/api/wordpress/validation';
            $result = '';
            $headers = array(
                'Api-Key' => $api_key,
                'Content-Type' => 'application/json'
            );
            $body = array(
                'hostname' => site_url(),
                'api_key' => $api_key
            );
            $args = array(
                'headers' => $headers,
                'body' => json_encode($body),
                'method' => 'POST'
            );
            $response = wp_remote_post($url, $args);
            if (is_wp_error($response)) {
                // handle error
            } else {
                $response_code = wp_remote_retrieve_response_code($response);
                $response_body = wp_remote_retrieve_body($response);
                $result = json_decode( $response_body ,true);
            }
            if( empty( $result ) ){
                $result["err"] = "API Key is wrong..!"; 
                echo json_encode($result);    
            }else{
                update_option( "reword_sync_call_reword_state" , $api_key );
                echo json_encode($result);    
            }
            
            die();
        }
    }

    /* API for activation and deactivation Ajax */
    public function reword_active_option(){
        if ( ! wp_verify_nonce( $_POST['nonce'], 'ajax-nonce' ) ) {
            die ("Somthing Went Wrong");
        }
        if( $_POST ){
           $option_active = get_option( 'reword_option_active', true );
            if( $option_active ){
                $url = 'https://api.reword.com/api/wordpress/deactivate';
                $api_key = get_option( "reword_sync_call_reword_state" );
                $headers = array(
                    'Api-Key' => $api_key,
                    'Content-Type' => 'application/json'
                );
                $response = wp_remote_post($url, array(
                    'method' => 'POST',
                    'headers' => $headers,
                ));

                // print_r($response);
                // exit;
               
                if (is_wp_error($response)) {
                    // handle error
                } else {
                    $response_code = wp_remote_retrieve_response_code($response);
                    $response_body = wp_remote_retrieve_body($response);
                    // handle response
                    $result = json_decode( $response_body );
                    if($response_code == 200){
                        update_option( "reword_option_active" , 0 );
                        update_option( "reword_sync_call_reword_state" , "" );
                    }
                }


            }else{
                update_option( "reword_option_active" , 1 );
            }
        }
        $option_active = get_option( 'reword_option_active' );
        
        $data = array(
            'status' => $option_active,
        );
        echo json_encode( $data );
        die();
    }
    
    public function crd_get_posts(){
        $args = array(
            'post_type'      => 'post', 
            'posts_per_page' => -1,
              'meta_query' => array(
                        'relation' => 'OR',
                        array(
                            'key' => 'post_uniq_key',
                            'compare' => 'NOT EXISTS',
                        ),
                        array(
                            'key' => 'post_uniq_key',
                            'value' => '',
                            'compare' => '=',
                        ),
                ),
        );
        $posts = get_posts($args);
        if(!empty($posts)){
            
  
            $chunked_posts = array_chunk($posts, 2);
            $pos_num = $_POST['pos_num'];
            $count = count($chunked_posts);
            $response = array();
            // if(!($chunked_posts[$pos_num])){
            if( array_key_exists( $pos_num , $chunked_posts ) ){
                foreach ($chunked_posts[$pos_num] as $post) {
                    $post_id = $post->ID;
                    $random_key = get_post_meta($post_id,'post_uniq_key',true);
                    if(empty($random_key)){
                        $post_date = get_post_field( 'post_date', $post_id );
                        $timestamp = strtotime( $post_date );
                        update_post_meta($post_id,'post_uniq_key',$timestamp);
                    }
                }
                $pos_num++;
                $response = array(
                    'response' => 'posts_done',
                    'num' => $pos_num,
                );
            }
            else{
                $response = array(
                    'complete' => 'posts_done',
                );
            }
        }else{
            
            $response = array(
                    'complete' => 'posts_done',
                );
            
        }
        echo json_encode( $response );
        die();
    }
}
    