<?php
/**
* class for initiating necessary actions and core functions.
*/
/*
* Defining Namespace
*/
namespace rewordsync\classes;
class Rewordsyncapi
{
    /*
     * Constructor for iniation.
    */
    public function __construct(){
        
        $this->init();
    }

     /** 
     * Initiating necessary functions
     */
    public function init(){
       
        add_action( 'rest_api_init' , array( $this, 'reword_sync_api_send' ));
       
        add_action( 'save_post_post' , array( $this , 'post_data_save' ) );
        add_action( 'publish_post', array( $this , 'post_published_api_call' ), 20, 2 );
     
        add_action( 'draft_post', array( $this , 'post_draft_api_call' ) ,10,3 );
        add_action( "admin_footer" , array( $this , 'footer_slug_url' ) );
        add_action( 'post_submitbox_misc_actions', array( $this , 'add_custom_field_to_publish_meta_box' ) );
        add_action( 'post_submitbox_start', array( $this , 'add_custom_field_to_publish_meta_box' ) );

        add_action( 'elementor/editor/after_save', array( $this, 'cotent_render_elementor_data' ),10, 2 );
        
    }

    /*  
    * Post Published API call when Elementor post updating
    */
    public function cotent_render_elementor_data( $post_id, $editor_data ) {
        $post = get_post($post_id);
        
        $content = apply_filters( 'the_content', $post->post_content ); 
        
        $author = $post->post_author; /* Post author ID. */
        $name = get_the_author_meta( 'display_name', $author );
        $title = $post->post_title;

        $post_status = $post->post_status;
        $permalink = get_permalink( $post_id );
        $slug = $post->post_name;
        $random_id = get_post_meta( $post_id , "post_uniq_key" , true );

        $post_status_api = get_post_meta( $post_id , "post_status_api", true );

        if( $post_status === 'publish' || $post_status === 'draft' ){
            
            if( $post_status_api != 'published' ){

                if($post_status === 'publish'){
                    $status  = 'publish_post';
                }elseif($post_status === 'draft'){
                    $status  = 'draft_post';
                }

                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => $status,
                   'slug' => $slug,
                   'url' => $permalink
                );


                $this->re_post_publish( $data );

                // $result = $this->validated_api();
                // if( $result == 'Validated!' ){
                    
                // }
            }else{

                if($post_status === 'publish'){
                    $status  = 'update_publish_post';
                }elseif($post_status === 'draft'){
                    $status  = 'update_draft_post';
                }
               
                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => $status,
                   'slug' => $slug,
                   'url' => $permalink
                   
                );

                $this->re_post_publish_updated( $data );
            }
        }
    }
    public function add_custom_field_to_publish_meta_box($post){
        ?>
        <div class="post-slug">
            <input type="text" name="custom_slug" id="custom_slug">
            <input type="text" name="custom_link" id="custom_link">    
        </div>
        <?php
    }
    function footer_slug_url(){
       
        ?>
        <script>
            jQuery( document ).on( "click" , "#save-post" , function(){
                let html_val = jQuery( "#sample-permalink a" ).html();
                html_val = html_val.replace(/<\/?span[^>]*>/g,"");
                jQuery( "#custom_link" ).val(html_val);
                let ht = html_val.split( "/" );
                let cnt = ht.length - 2;
                jQuery( "#custom_slug" ).val(ht[cnt]);
                
            } )
        </script>
        
        
        <?php
    }
    // Function For set random post meta key
    public function post_data_save($post_id){
        $rand = time();
        $random_id = get_post_meta( $post_id , "post_uniq_key" , true );
        if( empty( $random_id ) ){
            update_post_meta( $post_id , "post_uniq_key" , $rand);
        }
    }
    // Function For send post data
    public function reword_sync_api_send(){
        // API endpoint to create a single post by Random id
        register_rest_route( 'wp/v1', '/reword_create_post',
    		array(
                'methods'               => 'POST',
                'callback'              => array( $this, 'wp_reword_create_post' ),
                'permission_callback'   => array( $this, 'authorize_api_request' ),
            )
        );
        // API endpoint to update a single Random id
        register_rest_route( 'wp/v1', '/reword_update_post/(?P<id>\d+)',
    		array(
                'methods'               => 'PATCH',
                'callback'              => array( $this, 'wp_reword_uppdate_post' ),
                'permission_callback'   => array( $this, 'authorize_api_request' ),
            )
        );
        // API endpoint to retrieve a single post by Random id
        register_rest_route('wp/v1', '/single_posts/(?P<id>\d+)', array(
                'methods'               => 'GET',
                'callback'              => array( $this, 'get_single_post' ),
                'permission_callback'   => array( $this, 'authorize_api_request' ),
            )
        );
        // API endpoint to retrieve all posts
        register_rest_route('wp/v1', '/all_posts', array(
                'methods'               => 'GET',
                'callback'              => array( $this, 'get_all_posts' ),
                'permission_callback'   => array( $this,'authorize_api_request' ),
            )
        );
        
        
        register_rest_route( 'wp/v1', '/api_key',
    		array(
                'methods'               => 'POST',
                'callback'              => array( $this, 'wp_reword_api_test' ),
                'permission_callback'   => array( $this, 'authorize_api_request' ),
            )
        );
       
    }
    public function wp_reword_api_test($request){
        $api_key = get_option("reword_sync_call");
         $parameters = $request->get_params();
         if( empty($parameters) ){
            $parameters = array();
         }
         $i = 0;
         if( array_key_exists( "hostname", $parameters) ){
            $url = site_url();
            
            if($parameters['hostname'] == $url){
                $i++;    
            }
         }
         if( array_key_exists( "api_key", $parameters) ){
            
            if($parameters['api_key'] == $api_key){
                $i++;    
            } 
         }
         $response = array();
         if( $i == 2 ){
             $response[ 'success' ] = "Api Key and Host is match";
             $response[ 'api_key' ] = $api_key;
             $response['hostname'] = $url;
             $response['wordpress']['hostname'] = $url;
             
         }else{
             $response[ 'success' ] = "Api Key or Host is not match";
            
         }
         echo json_encode($response);
         die();
    }
    /**
     * Create post by random id
     */
   
    public function wp_reword_create_post($request){
        
        global $wpdb;
        $parameters = $request->get_params();
        
        // Extract required data from the request
        $random_id = "";
        if( isset( $parameters['random_id'] ) ) {
            $random_id = intval( ( $parameters['random_id'] ) );
        }else{
            return array(
                'success' => false,
                'message' => 'Invalid random id',
            );
        }
        $opt_active = get_option( "reword_option_active" );
       
        $table = $wpdb->prefix . 'postmeta';
        $post_data_val = $wpdb->get_results("SELECT * FROM $table WHERE meta_value = $random_id");
        
        if($opt_active){
            if( empty( $post_data_val ) ){
                if( !empty( $random_id ) ){
                    $title              = sanitize_text_field( $parameters['title']);
                    $content            =  $parameters['content'];
                    $status             = sanitize_text_field( $parameters['status']);
                    $slug             = sanitize_text_field( $parameters['slug']);
                    // Create the post
                    $post_id = wp_insert_post( array(
                        'post_title'    => $title,
                        'post_content'  => $content,
                        'post_status'   => $status,
                        'post_slug' => $slug,
                    ) );
                    $post = array(
                        'ID'        => $post_id,
                        'post_name' => $slug,
                    );
                    wp_update_post( $post );
                    update_post_meta( $post_id , "post_uniq_key" , $random_id );
                    if( $post_id ) {
                        return array(
                            'success'   => true,
                            'message'   => 'Post created successfully.',
                            'post_id'   => $post_id,
                        );
                    } else {
                        return array(
                            'success'   => false,
                            'message'   => 'Failed to create post.',
                        );
                    }
                }else{
                    return  array(
                        'success' => false,
                        'message' => 'Rendom ID is Blank..!',
                    );
                }
            }else{
                return  array(
                    'success' => false,
                    'message' => 'Post already created',
                );
            }
        }else{
            return  array(
                'success' => false,
                'message' => 'License not activated',
            );
        }
        
    }
    //End
    /**
     * Update post by random id
     */
    function wp_reword_uppdate_post( $request ) {
        global $wpdb;
        $parameters = $request->get_params();
        
        // Extract required data from the request
        if( isset( $parameters['id'] ) ) {
            $random_id = intval( ( $parameters['id'] ) );
        }else{
            return array(
                'success' => false,
                'message' => 'Invalid random id',
            );
        }

        $opt_active = get_option( "reword_option_active" );

        $table = $wpdb->prefix . 'postmeta';
        $post_data_val = $wpdb->get_results("SELECT * FROM $table WHERE meta_value = $random_id");
        $post_id = $post_data_val[0]->post_id;
        
        if($opt_active){
            if( !empty( $post_data_val ) ){
                update_post_meta($post_id, '_elementor_data', '');
                // Extract required data from the request
                $title      = sanitize_text_field($parameters['title']);
                $content    = wp_kses_post($parameters['content']);
                $status     = sanitize_text_field( $parameters['status']);
                $slug       = sanitize_text_field( $parameters['slug']);
                // Update the post
                $post = array(
                    'ID' => $post_id,
                    'post_title'    => $title,
                    'post_content'  => $content,
                    'post_status'   => $status,
                    'post_name'     => $slug,
                );
                
                $updated = wp_update_post($post, true);
            
                if (!is_wp_error($updated)) {
                    return array(
                        'success' => true,
                        'message' => 'Post updated successfully.',
                        'post_id' => $post_id,
                    );
                } else {
                    return array(
                        'success' => false,
                        'message' => 'Failed to update post.',
                    );
                }
            }else{
                return array(
                    'success' => false,
                    'message' => 'Post not found',
                );
            }
        }else{
            return array(
                'success' => false,
                'message' => 'License not activated',
            );
        }

    }
    //End
    /**
     * Get single post by random id
     */
    function get_single_post( $request ) {
        global $wpdb;
        $parameters = $request->get_params();
       
        // Extract required data from the request
        if( isset( $parameters['id'] ) ) {
            $random_id = intval( ( $parameters['id'] ) );
        }else{
            return array(
                'success' => false,
                'message' => 'Invalid random id',
            );
        }
        
        $table = $wpdb->prefix . 'postmeta';
        $post_data_val = $wpdb->get_results("SELECT * FROM $table WHERE meta_value = $random_id");
        $post_id = $post_data_val[0]->post_id;
        
        if( !empty( $post_data_val ) ){
    
            $post = get_post($post_id);
            $author = $post->post_author; /* Post author ID. */
            $name = get_the_author_meta( 'display_name', $author );
            $permalink = get_permalink( $post_id );
            if ($post) {
                $response = array(
                    'random_id'     => $random_id,
                    'title'         => $post->post_title,
                    'content'       => $post->post_content,
                    'author'        => $name,
                    'status'        => $post->post_status,
                    'slug'          => $post->post_name,
                    'url'           => $permalink,
                    'modified_date' => $post->post_modified
                );
            } else {
                $response = array(
                    'success' => false,
                    'message' => 'Post not found.',
                );
            }
        }
        return $response;
    }
    function get_all_posts( $request ) {
       
        $slug = $request->get_param('slug');
        $random_id = $request->get_param('random_id');
        $post_status = $request->get_param('post_status');

        // Prepare query arguments
        $query_args = array(
            'post_type' => 'post',
            'posts_per_page' => -1,
        );
        if ($slug) {
            $query_args['name'] = $slug;
        }
    
        if ($random_id) {
            $query_args['meta_query'] = array(
                array(
                    'key' => 'post_uniq_key', // Replace with your actual meta key
                    'value' => $random_id,
                    'compare' => '=',
                ),
            );
        }
    
        if ($post_status) {
            $query_args['post_status'] = $post_status;
        } else {
            $query_args['post_status'] = array('publish', 'draft'); // Default post statuses
        }
        
     
        $posts = get_posts( $query_args );
     
        $response = array();
        foreach ( $posts as $post ) {
            
            $author = $post->post_author; /* Post author ID. */
            $name = get_the_author_meta( 'display_name', $author );
            $permalink = get_permalink( $post->ID );
            $random_id = get_post_meta( $post->ID , "post_uniq_key" , true );
            $response[] = array(
                'random_id'     => $random_id,
                'title'         => $post->post_title,
                'content'       => $post->post_content,
                'author'        => $name,
                'status'        => $post->post_status,
                'slug'          => $post->post_name,
                'url'           => $permalink,
                'modified_date' => $post->post_modified
            );
        }
        
        if(empty($response)) {
            $response = array(
                'success' => false,
                'message' => 'No posts found.',
            );
        }
        
        return $response;
    }
    /**
     * Authorize API
     */
    function authorize_api_request() {
        // Replace 'YOUR_API_KEY' with your actual API key
        $api_key = get_option( "reword_sync_call_reword_state" );

        $headers = getallheaders();

        //$headers = getallheaders();
        if (!isset( $headers['Api-Key']) || $headers['Api-Key'] !== $api_key) {
            
            return new \WP_Error('rest_forbidden', 'Unauthorized request.', array('status' => 401));
        }
       
        return true;
    }
    //End
   
    // POST Delete API
  
   
    /**
     * Valiedated API
     * */
    function validated_api(){
      
        //Validation API
        $url = 'https://api.reword.com/api/wordpress/validation';
        $result = '';
        $get_api_key = get_option( "reword_sync_call" );
        $api_key = get_option( "reword_sync_call_reword_state" );
        
        
        if( !empty( $api_key ) ){
            $headers = array(
                'Api-Key' => $api_key,
                'Content-Type' => 'application/json'
            );
    
            $body = array(
                'hostname' => site_url(),
                'api_key' => $get_api_key,
            );
    
            $args = array(
                'headers' => $headers,
                'body' => json_encode($body),
                'method' => 'POST'
            );
            
    
            $response = wp_remote_post($url, $args);
           
    
            if (is_wp_error($response)) {
    
                // handle error
    
            } else {
                $response_code = wp_remote_retrieve_response_code($response);
                $response_body = wp_remote_retrieve_body($response);
                $result = json_decode( $response_body );
            }
    
            return $result->result;
        }else{
            return "failed";
        }
        
        
    }
    /*END*/

    


    function post_published_api_call( $post_id, $post  ) {
        if ( wp_is_post_revision( $post_id ) )
            return;

        $author = $post->post_author; /* Post author ID. */
        $name = get_the_author_meta( 'display_name', $author );
        $title = $post->post_title;
        
        if ( class_exists('Elementor\Plugin') && \Elementor\Plugin::$instance->db->is_built_with_elementor($post_id) ) {
            // $elementor_data = get_post_meta($post_id, '_elementor_data', true); // Retrieve Elementor data
            // $elementor_data = json_decode($elementor_data, true); // Decode the Elementor data
            return;
        }


        $content = $post->post_content;
        $content = apply_filters( 'the_content', $content ); 

        $post_status = $post->post_status;
        $permalink = get_permalink( $post_id );
        $slug = $post->post_name;
        $random_id = get_post_meta( $post_id , "post_uniq_key" , true );
        
        if( $post_status == 'publish' ){

           
            if( $post->post_date == $post->post_modified ){
                

                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => 'publish_post',
                   'slug' => $slug,
                   'url' => $permalink
                );
                
                $this->re_post_publish( $data );

                // $result = $this->validated_api();
                // if( $result == 'Validated!' ){
                    
                // }
            }else{
               
                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => 'update_publish_post',
                   'slug' => $slug,
                   'url' => $permalink
                   
                );
                
                $this->re_post_publish_updated( $data );
            }
        }
    }
    function post_draft_api_call( $post_id, $post, $old_status ) {
        
        $author = $post->post_author; /* Post author ID. */
        $name = get_the_author_meta( 'display_name', $author );
        $email = get_the_author_meta( 'user_email', $author );
       
        $title = $post->post_title;
        $content = $post->post_content;
        $post_status = $post->post_status;
        $permalink = $post->guid;
        $slug = sanitize_title($post->post_title);
        $random_id = get_post_meta( $post_id , "post_uniq_key" , true );

        $drafted = get_post_meta( $post_id, 'drafted', true );
        
        if( $post_status == 'draft' ){
            //if( $post->post_date == $post->post_modified ){
            
            if( empty( $drafted ) ){
              
                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => 'draft_post',
                   'slug' => $slug,
                   'url' => $permalink
                );

                $this->re_draft_api_call( $data );
                update_post_meta( $post_id , "drafted" , 1 );
            }else{
               
                $data = array(
                   'id' => $post_id,
                   'random_id' => $random_id,
                   'title' => $title,
                   'content' => $content,
                   'author' => $name,
                   'status' => 'update_draft_post',
                   'slug' => $slug,
                   'url' => $permalink
                );
                
                $this->re_draft_updated_api_call( $data );
            }
            
            
            $post_id = $data['id']; 
            
            $elementor_edit_mode = get_post_meta($post_id, '_elementor_edit_mode', true);
            
            if ($elementor_edit_mode === 'builder') {
            
            } else {
              sleep(3);
            }
        }
    }
    /**
     * API call post publish 
     * */
    function re_post_publish( $data ){

        //Publish Post api
        $post_id = $data['id']; 

        $url = 'https://api.reword.com/api/wordpress/published';
        $api_key = get_option( "reword_sync_call_reword_state" );
        $headers = array(
            'Api-Key' => $api_key,
            'Content-Type' => 'application/json'
        );
        $response = wp_remote_post($url, array(
            'method' => 'POST',
            'headers' => $headers,
            'body' => json_encode($data)
        ));
       
        if (is_wp_error($response)) {
            // handle error
        } else {
            $response_code = wp_remote_retrieve_response_code($response);
            $response_body = wp_remote_retrieve_body($response);
            // handle response
            $result = json_decode( $response_body );
            

            if($response_code == '200'){
                update_post_meta( $post_id , "post_status_api" , 'published' );
            }
           
        }
       
        $elementor_edit_mode = get_post_meta($post_id, '_elementor_edit_mode', true);
        
        if ($elementor_edit_mode === 'builder') {
        
        } else {
          sleep(3);
        }
    }
    
    /*  
    * API Call for post updating
    */
    function re_post_publish_updated( $data ){
       
        //Publish Post api
        $url = 'https://api.reword.com/api/wordpress/updated';
        $api_key = get_option( "reword_sync_call_reword_state" );
        $headers = array(
            'Api-Key' => $api_key,
            'Content-Type' => 'application/json'
        );
        $response = wp_remote_post($url, array(
            'method' => 'POST',
            'headers' => $headers,
            'body' => json_encode($data)
        ));

       
        if (is_wp_error($response)) {
            // handle error
        } else {
            $response_code = wp_remote_retrieve_response_code($response);
            $response_body = wp_remote_retrieve_body($response);
            // handle response
            $result = json_decode( $response_body );
           
        }
        
        $post_id = $data['id']; 

        $elementor_edit_mode = get_post_meta($post_id, '_elementor_edit_mode', true);
        
        if ($elementor_edit_mode === 'builder') {
        
        } else {
          sleep(3);
        }   
    }
    /*END*/
    
    /**
     * API call post Draft post publish
     */
    function re_draft_api_call( $data ){
        
        $url = 'https://api.reword.com/api/wordpress/published';
        $api_key = get_option( "reword_sync_call_reword_state" );
        
        $headers = array(
            'Api-Key' => $api_key,
            'Content-Type' => 'application/json'
        );
        $response = wp_remote_post($url, array(
            'method' => 'POST',
            'headers' => $headers,
            'body' => json_encode($data)
        ));

        
        if (is_wp_error($response)) {
            // handle error
        } else {
            $response_code = wp_remote_retrieve_response_code($response);
            $response_body = wp_remote_retrieve_body($response);
            // handle response
            $result = json_decode( $response_body );
           
        }
    }

    /**
     * API call post draft updated
     */
    function re_draft_updated_api_call( $data ){

        $url = 'https://api.reword.com/api/wordpress/updated';
        $api_key = get_option( "reword_sync_call_reword_state" );
        $headers = array(
            'Api-Key' => $api_key,
            'Content-Type' => 'application/json'
        );
        $response = wp_remote_post($url, array(
            'method' => 'POST',
            'headers' => $headers,
            'body' => json_encode($data)
        ));


        if (is_wp_error($response)) {
            // handle error
        } else {
            $response_code = wp_remote_retrieve_response_code($response);
            $response_body = wp_remote_retrieve_body($response);
           
            // handle response
            $result = json_decode( $response_body );
          
        }
    }
    
}